Connection = require('../../src/connection')
Request = require('../../src/request')
fs = require('fs')
TYPES = require('../../src/data-type').typeByName

getConfig = ->
  config = JSON.parse(fs.readFileSync(process.env.HOME + '/.tedious/test-connection.json', 'utf8')).config

  config.options.debug =
    packet: false
    data: false
    payload: false
    token: false
    log: false

  config

nVarCharMax = (test) ->
  longString = ''
  for i in [1..(100 * 1000)]
    longString += 'x'

  execSql(test, TYPES.NVarChar, longString)

execSql = (test, type, value) ->
  test.expect(5)

  config = getConfig()

  request = new Request('select @param', (err) ->
      test.ok(!err)

      connection.close()
  )

  request.addParameter('param', type, value)

  request.on('doneInProc', (rowCount, more) ->
      test.ok(more)
      test.strictEqual(rowCount, 1)
  )

  request.on('row', (columns) ->
      test.strictEqual(columns.length, 1)

      if (value instanceof Date)
        test.strictEqual(columns[0].value.getTime(), value.getTime())
      else
        test.strictEqual(columns[0].value, value)
  )

  connection = new Connection(config)

  connection.on('connect', (err) ->
      connection.execSql(request)
  )

  connection.on('end', (info) ->
      test.done()
  )

  connection.on('errorMessage', (error) ->
    console.log("#{error.number} : #{error.message}")
  )

  connection.on('debug', (text) ->
    #console.log(text)
  )

nVarCharMax()
