// Generated by CoffeeScript 1.3.1
(function() {
  var Connection, Request, TYPES, execSql, fs, getConfig, nVarCharMax;

  Connection = require('../../src/connection');

  Request = require('../../src/request');

  fs = require('fs');

  TYPES = require('../../src/data-type').typeByName;

  getConfig = function() {
    var config;
    config = JSON.parse(fs.readFileSync(process.env.HOME + '/.tedious/test-connection.json', 'utf8')).config;
    config.options.debug = {
      packet: false,
      data: false,
      payload: false,
      token: false,
      log: false
    };
    return config;
  };

  nVarCharMax = function(test) {
    var i, longString, _i, _ref;
    longString = '';
    for (i = _i = 1, _ref = 100 * 1000; 1 <= _ref ? _i <= _ref : _i >= _ref; i = 1 <= _ref ? ++_i : --_i) {
      longString += 'x';
    }
    return execSql(test, TYPES.NVarChar, longString);
  };

  execSql = function(test, type, value) {
    var config, connection, request;
    test.expect(5);
    config = getConfig();
    request = new Request('select @param', function(err) {
      test.ok(!err);
      return connection.close();
    });
    request.addParameter('param', type, value);
    request.on('doneInProc', function(rowCount, more) {
      test.ok(more);
      return test.strictEqual(rowCount, 1);
    });
    request.on('row', function(columns) {
      test.strictEqual(columns.length, 1);
      if (value instanceof Date) {
        return test.strictEqual(columns[0].value.getTime(), value.getTime());
      } else {
        return test.strictEqual(columns[0].value, value);
      }
    });
    connection = new Connection(config);
    connection.on('connect', function(err) {
      return connection.execSql(request);
    });
    connection.on('end', function(info) {
      return test.done();
    });
    connection.on('errorMessage', function(error) {
      return console.log("" + error.number + " : " + error.message);
    });
    return connection.on('debug', function(text) {});
  };

  nVarCharMax();

}).call(this);
