// Generated by CoffeeScript 1.3.1
var metadataParse, parser;

metadataParse = require('../metadata-parser');

parser = function(buffer) {
  var c, colName, column, columnCount, columns, metadata, numberOfTableNameParts, part, tableName, _i;
  columnCount = buffer.readUInt16LE();
  columns = [];
  for (c = _i = 1; 1 <= columnCount ? _i <= columnCount : _i >= columnCount; c = 1 <= columnCount ? ++_i : --_i) {
    metadata = metadataParse(buffer);
    if (metadata.type.hasTableName) {
      numberOfTableNameParts = buffer.readUInt8();
      tableName = (function() {
        var _j, _results;
        _results = [];
        for (part = _j = 1; 1 <= numberOfTableNameParts ? _j <= numberOfTableNameParts : _j >= numberOfTableNameParts; part = 1 <= numberOfTableNameParts ? ++_j : --_j) {
          _results.push(buffer.readUsVarchar('ucs2'));
        }
        return _results;
      })();
    } else {
      tableName = void 0;
    }
    colName = buffer.readBVarchar();
    column = {
      userType: metadata.userType,
      flags: metadata.flags,
      type: metadata.type,
      colName: colName,
      collation: metadata.collation,
      precision: metadata.precision,
      scale: metadata.scale,
      dataLength: metadata.dataLength,
      tableName: tableName
    };
    columns.push(column);
    columns[column.colName] = column;
  }
  return {
    name: 'COLMETADATA',
    event: 'columnMetadata',
    columns: columns
  };
};

module.exports = parser;
